"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactHooksPlugin = void 0;
const logger_1 = require("./logger");
const decorator_1 = require("./decorator");
const service_1 = require("./service");
const config_1 = require("./config");
class ReactHooksPlugin {
    constructor(typescript) {
        this.typescript = typescript;
    }
    create(info) {
        var _a;
        const config = (_a = info.config) !== null && _a !== void 0 ? _a : {};
        this.logger = new logger_1.LanguageServiceLogger(info);
        this.configManager = new config_1.ConfigManager(config);
        this.logger.log('create config: ' + JSON.stringify(config));
        return new decorator_1.TemplateLanguageServiceProxy(new service_1.CustomizedLanguageService(info, this.typescript, this.logger, this.configManager)).decorate(info.languageService);
    }
    onConfigurationChanged(config) {
        var _a, _b;
        (_a = this.logger) === null || _a === void 0 ? void 0 : _a.log('update config: ' + JSON.stringify(config));
        (_b = this.configManager) === null || _b === void 0 ? void 0 : _b.update(config);
    }
}
exports.ReactHooksPlugin = ReactHooksPlugin;
//# sourceMappingURL=plugin.js.map